--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--								University of Hawaii at Manoa						         --
--						Instrumentation Development Lab / GARY S. VARNER				--
--   								Watanabe Hall Room 214								      --
--  								  2505 Correa Road										   --
--  								 Honolulu, HI 96822											--
--  								Lab: (808) 956-2920											--
--	 								Fax: (808) 956-2930										   --
--  						E-mail: idlab@phys.hawaii.edu									   --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------	
-- Design by: Larry L. Ruckman Jr.															--
-- DATE : 23 JUNE 2007																			--
-- Project name: ICRR firmware																--
--	Module name: BUF12			  																--
--	Description : 																					--
-- 	Buffer 12 bits wide																		--
--		  											    												--
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity BUF12 is
   port ( 
          I  	: in    std_logic_vector (11 downto 0);
          O		: out   std_logic_vector (11 downto 0));
end BUF12;

architecture Behavioral of BUF12 is
--------------------------------------------------------------------------------
--   								components     		   						         --
--------------------------------------------------------------------------------
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
--------------------------------------------------------------------------------
begin
--------------------------------------------------------------------------------		
	xBUF_0 : BUF 
	port map (
		I  => I(0),
		O  => O(0));
--------------------------------------------------------------------------------		
	xBUF_1 : BUF 
	port map (
		I  => I(1),
		O  => O(1));
--------------------------------------------------------------------------------		
	xBUF_2 : BUF 
	port map (
		I  => I(2),
		O  => O(2));
--------------------------------------------------------------------------------		
	xBUF_3 : BUF 
	port map (
		I  => I(3),
		O  => O(3));
--------------------------------------------------------------------------------		
	xBUF_4 : BUF 
	port map (
		I  => I(4),
		O  => O(4));
--------------------------------------------------------------------------------		
	xBUF_5 : BUF 
	port map (
		I  => I(5),
		O  => O(5));
--------------------------------------------------------------------------------		
	xBUF_6 : BUF 
	port map (
		I  => I(6),
		O  => O(6));
--------------------------------------------------------------------------------		
	xBUF_7 : BUF 
	port map (
		I  => I(7),
		O  => O(7));
--------------------------------------------------------------------------------		
	xBUF_8 : BUF 
	port map (
		I  => I(8),
		O  => O(8));
--------------------------------------------------------------------------------		
	xBUF_9 : BUF 
	port map (
		I  => I(9),
		O  => O(9));
--------------------------------------------------------------------------------		
	xBUF_10 : BUF 
	port map (
		I  => I(10),
		O  => O(10));
--------------------------------------------------------------------------------		
	xBUF_11 : BUF 
	port map (
		I  => I(11),
		O  => O(11));
--------------------------------------------------------------------------------		
end Behavioral;