--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--								University of Hawaii at Manoa						         --
--						Instrumentation Development Lab / GARY S. VARNER				--
--   								Watanabe Hall Room 214								      --
--  								  2505 Correa Road										   --
--  								 Honolulu, HI 96822											--
--  								Lab: (808) 956-2920											--
--	 								Fax: (808) 956-2930										   --
--  						E-mail: idlab@phys.hawaii.edu									   --
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------	
-- Design by: Larry L. Ruckman Jr.															--
-- DATE : 23 JUNE 2007																			--
--	Module name: IBUF5			  																--
--	Description : 																					--
-- 	Input buffer 5 bits wide with buffering											--
--		  											    												--
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity IBUF4X is
   port ( 
          I  	: in    std_logic_vector (3 downto 0);
          O		: out   std_logic_vector (3 downto 0));
end IBUF4X;

architecture Behavioral of IBUF4X is
	signal BUF_INPUT	: std_logic_vector(3 downto 0);
--------------------------------------------------------------------------------
--   								components     		   						         --
--------------------------------------------------------------------------------
   component BUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
--------------------------------------------------------------------------------
   component IBUF
      port ( I : in    std_logic; 
             O : out   std_logic);
   end component;
--------------------------------------------------------------------------------
begin
--------------------------------------------------------------------------------		
	xIBUF_0 : IBUF 
	port map (
		I  => I(0),
		O  => BUF_INPUT(0));
--------------------------------------------------------------------------------		
	xIBUF_1 : IBUF 
	port map (
		I  => I(1),
		O  => BUF_INPUT(1));
--------------------------------------------------------------------------------		
	xIBUF_2 : IBUF 
	port map (
		I  => I(2),
		O  => BUF_INPUT(2));
--------------------------------------------------------------------------------		
	xIBUF_3 : IBUF 
	port map (
		I  => I(3),
		O  => BUF_INPUT(3));
--------------------------------------------------------------------------------		
	xBUF_0 : BUF 
	port map (
		I  => BUF_INPUT(0),
		O  => O(0));
--------------------------------------------------------------------------------		
	xBUF_1 : BUF 
	port map (
		I  => BUF_INPUT(1),
		O  => O(1));
--------------------------------------------------------------------------------		
	xBUF_2 : BUF 
	port map (
		I  => BUF_INPUT(2),
		O  => O(2));
--------------------------------------------------------------------------------		
	xBUF_3 : BUF 
	port map (
		I  => BUF_INPUT(3),
		O  => O(3));
--------------------------------------------------------------------------------		
end Behavioral;