`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    20:53:17 03/28/07
// Design Name:    
// Module Name:    txdata_gen
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module data_trans(txusrclk2, reset, enable, xTX_DATA
                  ,txdata, txcharisk, xTX_BUSY
						);

		input txusrclk2, reset, enable;
		input [31:0]xTX_DATA;

		output [31:0]txdata;
		output [3:0] txcharisk;
		output xTX_BUSY;

reg [31:0] txdata, txdata_int;
reg [3:0]  txcharisk, txcharisk_int;

reg [7:0]  startup_counter;
reg        txgen_int;


	 wire          gen_enable;
	 wire          tx_gen_reset;
	 reg   [6:0]   cnt = 7'b0;
	 reg   			tc;
	 reg           comma, xTX_BUSY;

parameter  INSERT_IDLE = 7'H7F;
assign gen_enable = txgen_int && (!comma);
assign tx_gen_reset = reset || !txgen_int;
											 
always@(posedge txusrclk2)
begin
	if(reset)
		begin
			txdata_int    <= 32'hbc95b5b5;
			txcharisk_int <= 4'b1000;
			startup_counter <= 8'b0;
			txgen_int <= 1'b0;
		end
	else if(enable)
		begin
			startup_counter <= startup_counter + 1;	
			if(startup_counter < 8'hE0)
				begin
					txdata_int    <= 32'hBC95B5B5;
					txcharisk_int <= 4'b1000;
				end
			else if(startup_counter < 8'hEF)
				begin
					txdata_int    <= 32'h7C95B5B5;
					txcharisk_int <= 4'b1000;
				end
			else if(startup_counter < 8'hFD)
				begin
					txdata_int    <= 32'hBC95B5B5;
					txcharisk_int <= 4'b1000;
				end
			else if(startup_counter < 8'hFF)
				begin
					txdata_int    <= 32'hFC95B5B5;
					txcharisk_int <= 4'b1000;
				end
			else
				begin
					txdata_int    <= 32'hBC95B5B5;
					txcharisk_int <= 4'b1000;
					txgen_int <= 1'b1;
				end
		end
	else
		begin
			txdata_int    <= 32'HBC95B5B5;
			txcharisk_int <= 4'b1000;
			startup_counter <= 8'b0;
			txgen_int <= 1'b0;
		end
end				
			





always@(posedge txusrclk2)
begin
  if(tx_gen_reset)
    begin
	   cnt <= 7'b0;
	   tc  <= 1'b0;
      comma <= 1'b0;
    end
  else if(txgen_int)
    begin
	   cnt <= cnt + 1;
	   if(cnt == INSERT_IDLE) 
		  begin  tc<=1'b1; end
		else
		  begin  tc<=1'b0; end
	 end
  comma <= tc;
end

always@(posedge txusrclk2)
   begin
			if(reset)
			  begin
			    txdata <= 32'b1;
				 xTX_BUSY <= 1'b1;
				 txcharisk <= 4'b0;
			  end
         else if(!txgen_int)
			  begin
			   txdata <= txdata_int;
				xTX_BUSY <= 1'b1;
				txcharisk <= txcharisk_int;
			  end
			else
	        begin
			   txcharisk <= {comma,3'b0};
				if(comma)
				  begin 
						txdata <= 32'HBC95B5B5; 
						xTX_BUSY <= 1'b1;
				  end
            else
				  begin 
						txdata <= xTX_DATA; 
						xTX_BUSY <= 1'b0;
				  end
           end
	end


endmodule
