////////////////////////////////////////////////////////////////////////////////
//Design Name: mgt
//Device: virtex2p4-5fg256c
//Purpose:
//
`timescale 1ns / 1ps

module mgt(		
		loopback
		,refclk
		,rxn,rxp
		,rxpolarity,txpolarity
		,rxreset,txreset
		,rxusrclk,rxusrclk2,txusrclk,txusrclk2
		,txdata,txcharisk
		,rxbufstatus,rxchariscomma,rxcharisk,rxcommadet
		,rxdata
		,rxlossofsync,rxrealign
		,txn,txp
);

		input [1:0]  loopback;
		input        refclk;
		input        rxn,rxp;
		input        rxpolarity,txpolarity;
		input        rxreset,txreset;
		input        rxusrclk,rxusrclk2,txusrclk,txusrclk2;
		input [31:0] txdata;
		input [3:0]  txcharisk;

		output [1:0] rxbufstatus;
//synthesis attribute KEEP of rxbufstatus is "true"
		output [3:0] rxchariscomma;
		output [3:0] rxcharisk;
		output       rxcommadet;
		output [31:0]rxdata;
		output [1:0] rxlossofsync;
//synthesis attribute KEEP of rxlossofsync is "true"

		output       rxrealign;
		output       txn,txp;

   
GT_CUSTOM INST_MGT (.BREFCLK(1'B0), 
                     .BREFCLK2(1'B0), 
                     .CHBONDI(), 
                     .CONFIGENABLE(), 
                     .CONFIGIN(), 
                     .ENCHANSYNC(1'b0), 
                     .ENMCOMMAALIGN(1'b1), 
                     .ENPCOMMAALIGN(1'b1), 
                     .LOOPBACK(loopback[1:0]), 
                     .POWERDOWN(1'b0), 
                     .REFCLK(refclk), 
                     .REFCLKSEL(1'b0), 
                     .REFCLK2(1'b0), 
                     .RXN(rxn), 
                     .RXP(rxp), 
                     .RXPOLARITY(rxpolarity), 
                     .RXRESET(rxreset), 
                     .RXUSRCLK(rxusrclk), 
                     .RXUSRCLK2(rxusrclk2), 
                     .TXBYPASS8B10B(4'b0), 
                     .TXCHARDISPMODE(4'b0), 
                     .TXCHARDISPVAL(4'b0), 
                     .TXCHARISK(txcharisk[3:0]), 
                     .TXDATA(txdata[31:0]), 
                     .TXFORCECRCERR(1'b0), 
                     .TXINHIBIT(1'b0), 
                     .TXPOLARITY(txpolarity), 
                     .TXRESET(txreset), 
                     .TXUSRCLK(txusrclk), 
                     .TXUSRCLK2(txusrclk2), 
                     .CHBONDDONE(), 
                     .CHBONDO(), 
                     .CONFIGOUT(), 
                     .RXBUFSTATUS(rxbufstatus[1:0]), 
                     .RXCHARISCOMMA(rxchariscomma[3:0]), 
                     .RXCHARISK(rxcharisk[3:0]), 
                     .RXCHECKINGCRC(), 
                     .RXCLKCORCNT(), 
                     .RXCOMMADET(rxcommadet), 
                     .RXCRCERR(), 
                     .RXDATA(rxdata[31:0]), 
                     .RXDISPERR(), 
                     .RXLOSSOFSYNC(rxlossofsync[1:0]), 
                     .RXNOTINTABLE(), 
                     .RXREALIGN(rxrealign), 
                     .RXRECCLK(), 
                     .RXRUNDISP(), 
                     .TXBUFERR(), 
                     .TXKERR(), 
                     .TXN(txn), 
                     .TXP(txp), 
                     .TXRUNDISP());
   // synthesis attribute ALIGN_COMMA_MSB of INST_MGT is "TRUE"
   // synthesis attribute CLK_COR_INSERT_IDLE_FLAG of INST_MGT is "FALSE"
   // synthesis attribute CLK_COR_KEEP_IDLE of INST_MGT is "FALSE"
   // synthesis attribute CLK_COR_REPEAT_WAIT of INST_MGT is "1"
   // synthesis attribute CLK_COR_SEQ_1_1 of INST_MGT is "00110111100" 
   // synthesis attribute CLK_COR_SEQ_1_2 of INST_MGT is "00010010101"
   // synthesis attribute CLK_COR_SEQ_1_3 of INST_MGT is "00010110101"
   // synthesis attribute CLK_COR_SEQ_1_4 of INST_MGT is "00010110101"
   // synthesis attribute CLK_COR_SEQ_2_USE of INST_MGT is "FALSE"
   // synthesis attribute CLK_COR_SEQ_LEN of INST_MGT is "4"
   // synthesis attribute CLK_CORRECT_USE of INST_MGT is "TRUE"
   // synthesis attribute COMMA_10B_MASK of INST_MGT is "1111111000"
   // synthesis attribute CRC_END_OF_PKT of INST_MGT is "K29_7"
   // synthesis attribute CRC_FORMAT of INST_MGT is "USER_MODE"
   // synthesis attribute CRC_START_OF_PKT of INST_MGT is "K27_7"
   // synthesis attribute DEC_MCOMMA_DETECT of INST_MGT is "TRUE"
   // synthesis attribute DEC_PCOMMA_DETECT of INST_MGT is "TRUE"
   // synthesis attribute DEC_VALID_COMMA_ONLY of INST_MGT is "TRUE"
   // synthesis attribute MCOMMA_10B_VALUE of INST_MGT is "1100000101"
   // synthesis attribute MCOMMA_DETECT of INST_MGT is "TRUE"
   // synthesis attribute PCOMMA_10B_VALUE of INST_MGT is "0011111010"
   // synthesis attribute PCOMMA_DETECT of INST_MGT is "TRUE"
   // synthesis attribute REF_CLK_V_SEL of INST_MGT is "0"
   // synthesis attribute RX_BUFFER_USE of INST_MGT is "TRUE"
   // synthesis attribute RX_CRC_USE of INST_MGT is "FALSE"
   // synthesis attribute RX_DATA_WIDTH of INST_MGT is "4"
   // synthesis attribute RX_DECODE_USE of INST_MGT is "TRUE"
   // synthesis attribute RX_LOS_INVALID_INCR of INST_MGT is "1"
   // synthesis attribute RX_LOS_THRESHOLD of INST_MGT is "4"
   // synthesis attribute RX_LOSS_OF_SYNC_FSM of INST_MGT is "TRUE"
   // synthesis attribute SERDES_10B of INST_MGT is "FALSE"
   // synthesis attribute TERMINATION_IMP of INST_MGT is "50"
   // synthesis attribute TX_BUFFER_USE of INST_MGT is "TRUE"
   // synthesis attribute TX_CRC_FORCE_VALUE of INST_MGT is "11010110"
   // synthesis attribute TX_CRC_USE of INST_MGT is "FALSE"
   // synthesis attribute TX_DATA_WIDTH of INST_MGT is "4"
   // synthesis attribute TX_DIFF_CTRL of INST_MGT is "500"
   // synthesis attribute TX_PREEMPHASIS of INST_MGT is "1"
   // synopsys translate_off
//   defparam INST_MGT.ALIGN_COMMA_MSB = "TRUE";
//   defparam INST_MGT.CHAN_BOND_LIMIT = 16;
//   defparam INST_MGT.CHAN_BOND_MODE = "OFF";
//   defparam INST_MGT.CHAN_BOND_OFFSET = 8;
//   defparam INST_MGT.CHAN_BOND_ONE_SHOT = "FALSE";
//   defparam INST_MGT.CHAN_BOND_SEQ_1_1 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_1_2 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_1_3 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_1_4 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_2_1 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_2_2 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_2_3 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_2_4 = 11'b00000000000;
//   defparam INST_MGT.CHAN_BOND_SEQ_2_USE = "FALSE";
//   defparam INST_MGT.CHAN_BOND_SEQ_LEN = 1;
//   defparam INST_MGT.CHAN_BOND_WAIT = 8;
//   defparam INST_MGT.CLK_CORRECT_USE = "TRUE";
//   defparam INST_MGT.CLK_COR_INSERT_IDLE_FLAG = "FALSE";
//   defparam INST_MGT.CLK_COR_KEEP_IDLE = "FALSE";
//   defparam INST_MGT.CLK_COR_REPEAT_WAIT = 1;
//   defparam INST_MGT.CLK_COR_SEQ_1_1 = 11'b00110111100;
//   defparam INST_MGT.CLK_COR_SEQ_1_2 = 11'b00010010101;
//   defparam INST_MGT.CLK_COR_SEQ_1_3 = 11'b00010110101;
//   defparam INST_MGT.CLK_COR_SEQ_1_4 = 11'b00010110101;
//   defparam INST_MGT.CLK_COR_SEQ_2_1 = 11'b00000000000;
//   defparam INST_MGT.CLK_COR_SEQ_2_2 = 11'b00000000000;
//   defparam INST_MGT.CLK_COR_SEQ_2_3 = 11'b00000000000;
//   defparam INST_MGT.CLK_COR_SEQ_2_4 = 11'b00000000000;
//   defparam INST_MGT.CLK_COR_SEQ_2_USE = "FALSE";
//   defparam INST_MGT.CLK_COR_SEQ_LEN = 4;
//   defparam INST_MGT.COMMA_10B_MASK = 10'b1111111000;
//   defparam INST_MGT.CRC_END_OF_PKT = "K29_7";
//   defparam INST_MGT.CRC_FORMAT = "USER_MODE";
//   defparam INST_MGT.CRC_START_OF_PKT = "K27_7";
//   defparam INST_MGT.DEC_MCOMMA_DETECT = "TRUE";
//   defparam INST_MGT.DEC_PCOMMA_DETECT = "TRUE";
//   defparam INST_MGT.DEC_VALID_COMMA_ONLY = "TRUE";
//   defparam INST_MGT.MCOMMA_10B_VALUE = 10'b1100000101;
//   defparam INST_MGT.MCOMMA_DETECT = "TRUE";
//   defparam INST_MGT.PCOMMA_10B_VALUE = 10'b0011111010;
//   defparam INST_MGT.PCOMMA_DETECT = "TRUE";
//   defparam INST_MGT.RX_BUFFER_USE = "TRUE";
//   defparam INST_MGT.RX_CRC_USE = "FALSE";
//   defparam INST_MGT.RX_DATA_WIDTH = 4;
//   defparam INST_MGT.RX_DECODE_USE = "TRUE";
//   defparam INST_MGT.RX_LOSS_OF_SYNC_FSM = "TRUE";
//   defparam INST_MGT.RX_LOS_INVALID_INCR = 1;
//   defparam INST_MGT.RX_LOS_THRESHOLD = 4;
//   defparam INST_MGT.TERMINATION_IMP = 50;
//   defparam INST_MGT.SERDES_10B = "FALSE";
//   defparam INST_MGT.TX_BUFFER_USE = "TRUE";
//   defparam INST_MGT.TX_CRC_FORCE_VALUE = 8'b11010110;
//   defparam INST_MGT.TX_CRC_USE = "FALSE";
//   defparam INST_MGT.TX_DATA_WIDTH = 4;
//   defparam INST_MGT.TX_DIFF_CTRL = 600;
//   defparam INST_MGT.TX_PREEMPHASIS = 0;
//   defparam INST_MGT.REF_CLK_V_SEL = 0;
   // synopsys translate_on
endmodule
