`timescale 1ns / 1ps
module mgt_top(
					LOOPBACK_IN, RXN_IN, RXP_IN, TXN_OUT, TXP_OUT
					,rxreset, txreset, xTX_BUSY
					,refclk, txusrclk, txusrclk2, rxusrclk, rxusrclk2
					,rx_data, xTX_DATA
					,rxpolarity, txpolarity
					);

input	[1:0] LOOPBACK_IN;
input       RXN_IN, RXP_IN;
input       rxreset, txreset;
input			refclk, txusrclk, txusrclk2, rxusrclk, rxusrclk2;
input 		rxpolarity, txpolarity;
input [31:0] xTX_DATA, rx_data;
output      TXN_OUT, TXP_OUT, xTX_BUSY;

wire [31:0] txdata, rxdata;
wire [31:0] xTX_DATA;
wire [3:0] txcharisk, rxcharisk, rxchariscomma;
wire [1:0] rxbufstatus, rxlossofsync;
wire       rxcommadet, rxrealign, xTX_BUSY;

mgt INST_MGT_1(
					      .loopback(LOOPBACK_IN[1:0]),
							.refclk(refclk),
							.rxn(RXN_IN),
							.rxp(RXP_IN),
							.rxpolarity(rxpolarity),
							.txpolarity(txpolarity),
							.rxreset(rxreset),
							.txreset(txreset),
							.rxusrclk(rxusrclk),
							.rxusrclk2(rxusrclk2),
							.txusrclk(txusrclk),
							.txusrclk2(txusrclk2),
							.txdata(txdata[31:0]),
							.txcharisk(txcharisk[3:0]),
							.rxbufstatus(rxbufstatus[1:0]),
							.rxchariscomma(rxchariscomma[3:0]),
							.rxcharisk(rxcharisk[3:0]),
							.rxcommadet(rxcommadet),
							.rxdata(rxdata[31:0]),
							.rxlossofsync(rxlossofsync[1:0]),
							.rxrealign(rxrealign),
							.txn(TXN_OUT),
							.txp(TXP_OUT)
							);

data_reception INST_DATA_RECEPTION(
							.rxusrclk2(rxusrclk2),
							.rxchariscomma(rxchariscomma[3:0]),
							.rxcharisk(rxcharisk[3:0]),
							.rxcommadet(rxcommadet),
							.rxdata(rxdata[31:0]),
							.rxrealign(rxrealign),
							.reset(rxreset),
							.rx_data(rx_data[31:0])
							);


data_trans INST_data_trans(
							.txusrclk2(txusrclk2),
							.reset(txreset),
							.enable(!txreset),
							.xTX_DATA(xTX_DATA[31:0]),
							.xTX_BUSY(xTX_BUSY),
                     .txdata(txdata[31:0]),
							.txcharisk(txcharisk[3:0])
							);
									
endmodule
