`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    21:45:06 03/28/07
// Design Name:    
// Module Name:    reset_gen
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module reset_gen(
						reset_in, reset_out, clk, locked
						);

			input reset_in;
			input clk;
			input locked;

			output reset_out;

reg [15:0] startup_counter;
reg        reset_int;
reg        reset_out;

always@(posedge clk or negedge locked or posedge reset_in)
begin
	if(reset_in)
		begin
			startup_counter <=16'b0;
			reset_int       <= 1'b1;
		end
	else if(!locked)
  		begin
			startup_counter <=16'b0;
			reset_int       <= 1'b1;
		end
	else
		begin
			if(startup_counter < 16'HF)
				begin
					startup_counter <= startup_counter + 1;
				end
			else if(startup_counter == 16'HF)
				begin
				   reset_int <=1'b0;	
				end
			else
				begin
					reset_int <= 1'b1;
					startup_counter <= 16'b0;
				end
		end

end

always@(posedge clk)

begin
	if(reset_in)
		begin
			reset_out <= 1'b1;
		end
	else
		begin
			reset_out <= reset_int;
		end
end

endmodule
